CON
        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000

CON
        Zeq0 = 0
        Zeq1 = 1
        Ceq0 = 0
        Ceq1 = 1

VAR

  long  Cog, TestVar

OBJ
  dbg   :       "PASDebug"                '<---- Add for Debugger 


PUB main

  Cog := cognew(@entry, @TestVar) + 1

  dbg.start(31,30,@entry)                 '<---- Add for Debugger

PUB stop

  if Cog
    cogstop(Cog~ -  1)

DAT

                        org     0
entry

'  --------- Debugger Kernel add this at Entry (Addr 0) ---------
   long $34FC1202,$6CE81201,$83C120B,$8BC0E0A,$E87C0E03,$8BC0E0A
   long $EC7C0E05,$A0BC1207,$5C7C0003,$5C7C0003,$7FFC,$7FF8
'  --------------------------------------------------------------
DAT

              ORG       0
entry

        '======= Subroutine TI (Test Instruction) executes the test instruction
        '======= with the given values for dest, source, Z flag and C flag.
        '======= destExp is the expected result of the instruction and
        '======= Zexp and Cexp are the expected Z and C flags after execution
        '======= The routine returns a bit mapped result after execution...
        '=======   if dest   does not equal destExp, %100 is set.
        '=======   if Z flag does not equal Zexp,    %010 is set
        '=======   if C flag does not equal Cexp,    %001 is set

''      declareSub TI( dest, source, Zin, Cin, destExp, Zexp, Cexp)

''      array ans[8]

''      symbolicConstants Zeq0  Zeq1  Ceq0  Ceq1

''      ans[0] = beginAnsTag  ' Add value that is easy to see in Gear listing
              mov       ans+0, beginAnsTag      

''      ans[1] = TI( conECA, 31, Zeq0, Ceq0, $00,    Zeq1, Ceq0)
              mov       TI_dest, conECA         
              mov       TI_source, #31          
              mov       TI_Zin, #Zeq0           
              mov       TI_Cin, #Ceq0           
              mov       TI_destExp, #$00        
              mov       TI_Zexp, #Zeq1          
              mov       TI_Cexp, #Ceq0          
              call      #TI                     
              mov       ans+1, TI_result        

''      ans[2] = TI( conECA, 28, Zeq0, Ceq0, $05,    Zeq0, Ceq0)
              mov       TI_dest, conECA         
              mov       TI_source, #28          
              mov       TI_Zin, #Zeq0           
              mov       TI_Cin, #Ceq0           
              mov       TI_destExp, #$05        
              mov       TI_Zexp, #Zeq0          
              mov       TI_Cexp, #Ceq0          
              call      #TI                     
              mov       ans+2, TI_result        

''      ans[3] = TI( conECA, 24, Zeq0, Ceq0, $53,    Zeq0, Ceq0)
              mov       TI_dest, conECA         
              mov       TI_source, #24          
              mov       TI_Zin, #Zeq0           
              mov       TI_Cin, #Ceq0           
              mov       TI_destExp, #$53        
              mov       TI_Zexp, #Zeq0          
              mov       TI_Cexp, #Ceq0          
              call      #TI                     
              mov       ans+3, TI_result        

''      ans[4] = TI( conECA, 16, Zeq0, Ceq0, con37B, Zeq0, Ceq0)
              mov       TI_dest, conECA         
              mov       TI_source, #16          
              mov       TI_Zin, #Zeq0           
              mov       TI_Cin, #Ceq0           
              mov       TI_destExp, con37B      
              mov       TI_Zexp, #Zeq0          
              mov       TI_Cexp, #Ceq0          
              call      #TI                     
              mov       ans+4, TI_result        

''      ans[5] = TI( conECA,  0, Zeq0, Ceq0, con421, Zeq0, Ceq0)
              mov       TI_dest, conECA         
              mov       TI_source, #0           
              mov       TI_Zin, #Zeq0           
              mov       TI_Cin, #Ceq0           
              mov       TI_destExp, con421      
              mov       TI_Zexp, #Zeq0          
              mov       TI_Cexp, #Ceq0          
              call      #TI                     
              mov       ans+5, TI_result        

''      ans[6] = TI( con765, 28, Zeq0, Ceq0, $0A,    Zeq0, Ceq1)
              mov       TI_dest, con765         
              mov       TI_source, #28          
              mov       TI_Zin, #Zeq0           
              mov       TI_Cin, #Ceq0           
              mov       TI_destExp, #$0A        
              mov       TI_Zexp, #Zeq0          
              mov       TI_Cexp, #Ceq1          
              call      #TI                     
              mov       ans+6, TI_result        

''      ans[7] = TI( con765, 24, Zeq0, Ceq0, $A6,    Zeq0, Ceq1)
              mov       TI_dest, con765         
              mov       TI_source, #24          
              mov       TI_Zin, #Zeq0           
              mov       TI_Cin, #Ceq0           
              mov       TI_destExp, #$A6        
              mov       TI_Zexp, #Zeq0          
              mov       TI_Cexp, #Ceq1          
              call      #TI                     
              mov       ans+7, TI_result        

''      ans[8] = TI( con765, 16, Zeq0, Ceq0, con6E1, Zeq0, Ceq1)
              mov       TI_dest, con765         
              mov       TI_source, #16          
              mov       TI_Zin, #Zeq0           
              mov       TI_Cin, #Ceq0           
              mov       TI_destExp, con6E1      
              mov       TI_Zexp, #Zeq0          
              mov       TI_Cexp, #Ceq1          
              call      #TI                     
              mov       ans+8, TI_result        

''      ans[9] = TI( con765,  0, Zeq0, Ceq0, con4C2, Zeq0, Ceq1)
              mov       TI_dest, con765         
              mov       TI_source, #0           
              mov       TI_Zin, #Zeq0           
              mov       TI_Cin, #Ceq0           
              mov       TI_destExp, con4C2      
              mov       TI_Zexp, #Zeq0          
              mov       TI_Cexp, #Ceq1          
              call      #TI                     
              mov       ans+9, TI_result        

''      ans[10] = endAnsTag  ' Add value that is easy to see in Gear listing
              mov       ans+10, endAnsTag       

''      loop
aac1                                            
''      endLoop
              jmp       #aac1                   
aac2                                            


'' beginsub TI {dest, source, Zin, Cin, destExp, Zexp, Cexp } 
TI                                              
''            
''            sub       TI_Zin,#1            wz,nr   ' Set Z flag = Zin
              sub       TI_Zin, #1              wz,nr
''            add       conFFF,TI_Cin        wc,nr   ' Set C flag = Cin
              add       conFFF, TI_Cin          wc,nr
''
''            {Execute the instruction under test and write Z and C flags}

''            rev       TI_dest, TI_source   wz,wc,wr
              rev       TI_dest, TI_source      wz,wc,wr
''            
''      if_z  sub  TI_Zexp,#1  
        if_z  sub       TI_Zexp, #1             
''      if_c  sub  TI_Cexp,#1
        if_c  sub       TI_Cexp, #1             
''
''            TI_result = 0
              mov       TI_result, #0           
''
''            if TI_Zexp <> 0           {Check for expected Z}
              cmp       TI_Zexp, #0             wc,wz
        if_e  jmp       #aac3                   
''              TI_result |= %010
              or        TI_result, #%010        
''            endif
aac3                                            
aac4                                            
''
''            if TI_Cexp <> 0           {Check for expected C}
              cmp       TI_Cexp, #0             wc,wz
        if_e  jmp       #aac5                   
''              TI_result |= %001
              or        TI_result, #%001        
''            endif
aac5                                            
aac6                                            
''
''            if TI_dest <> TI_destExp
              cmp       TI_dest, TI_destExp     wc,wz
        if_e  jmp       #aac7                   
''              TI_result |= %100
              or        TI_result, #%100        
''            endif
aac7                                            
aac8                                            
''             
'' endSub   TI
TI_ret        ret                               

beginAnsTag   long      $AAAA_AAAA
endAnsTag     long      $BBBB_BBBB

conFFF        long      $FFFF_FFFF ' -1
conECA        long      $8421_DECA
con37B        long      $0000_537B
con421        long      $537B_8421
con765        long      $4321_8765
con6E1        long      $0000_A6E1
con4C2        long      $A6E1_84C2

''            finishCodeSection
'
' Subroutine parameters.....
'
TI_result                 res       1                       
TI_dest                   res       1                       
TI_source                 res       1                       
TI_Zin                    res       1                       
TI_Cin                    res       1                       
TI_destExp                res       1                       
TI_Zexp                   res       1                       
TI_Cexp                   res       1                       
ans                       res       8  {auto generated}     

              fit       496

